<?php
/*
Plugin Name: 优选图片本地化
Version: 2.0
Plugin URL: http://www.luyuz.cn
Description: 编辑文章，勾选图片本地化选择框，点击 “保存并返回” 按钮即可将远程图片本地化。能不能不要改我这个作者版权，我真的爱你们，真的真的以后都不想发布免费插件了！！！
Author: 小高教学网
Author Email: 84065994@qq.com
Author URL: https://www.luyuz.cn
*/
ini_set('max_execution_time', 60);
/**
 * V2.0 更新内容
 * - 去除摘要内容中图片本地化
 * - 优化图片下载方法，对抗防盗链
 * - 解决图片超时问题
 * - 优化超链接标签没有替换本地图片链接的问题
 * - 亲！保留版权啊（小高教学网：www.12580sky.com，有更多的免费Emlog插件！）！小东开发插件也不容易，而且大部分都是免费提供给大家，只希望给Emlog社区贡献更多有价值的内容，您的支持就是我创作的最大动力！！！
 * - 说实话，这样一个小插件申请国家软件著作权也很快，但作为一名开发者，其实希望的是用户越多越好，而不是和大家产生利益、法律纠纷！
 * - 当你改了版权的时候，使用插件/软件的用户，又该找谁？如果你是一名开发者，我相信你不会修改，如果是非开发者，希望尽量尊重小东的劳动成果，毕竟是免费分享给大家的，熬夜写出来的程序，免费使用，我只求大家保留版权，仅此而已，谢谢！
 */

include('getImage.php');

function img2local($logid) {
    global $logData;
    $Log_Model = new Log_Model();
    $isImg2local = isset($_POST['img2local']) ? trim($_POST['img2local']) : false;
    if(!$isImg2local) { return; }
	$logData['content'] = stripslashes($logData['content']);
	$logData['content'] = preg_replace_callback("/<a([^>]+)href=\"([^>\"]+)\"?([^>]*)><img([^>]+)src=\"([^>\"]+)\"?([^>]*)>/i","aandimage2local", $logData['content']);
    $logData['content'] = preg_replace_callback("/<img([^>]+)src=\"([^>\"]+)\"?([^>]*)>/i","image2local", $logData['content']);
	$logData['content'] = addslashes($logData['content']);
    $Log_Model->updateLog($logData,$logid);
}
addAction('save_log', 'img2local');

/**
 * Author: 小高教学网
 * Email: 小高教学网
 * webseite: http://www.12580sky.com
 */
function image2local($matches)
{
	$url = parse_url($matches[2]);
	$host = $_SERVER['HTTP_HOST'];
	$domain = BLOG_URL;
	// 当请求的url和当前网站域名不一致时候，才本地化
	if(isset($url['host']) && $url['host'] != $host) {
		// 图片文件名
		$imgName = md5(addslashes($matches[2])).'.jpg';
		// 保存网络图片
		// 保存图片的文件夹
		$uppath = '../content/top15img/'.gmdate('Ym') . '/';
		$fname = md5($imgName.gmdate('YmdHis'))  .'.jpg';
		$save_img_url = getImage($matches[2], $uppath, $fname, 0, $domain);
		
		return "<img{$matches[1]}src=\"{$save_img_url}\"{$matches[3]}>";
	} else {
		return "<img{$matches[1]}src=\"{$matches[2]}\"{$matches[3]}>";
	}
}

function aandimage2local($matches) {
	$url = parse_url($matches[5]);
	$host = $_SERVER['HTTP_HOST'];
	$domain = BLOG_URL;
	// 当请求的url和当前网站域名不一致时候，才本地化
	if(isset($url['host']) && $url['host'] != $host) {
		// 图片文件名
		$imgName = md5(addslashes($matches[5])).'.jpg';
		// 保存网络图片
		// 保存图片的文件夹
		$uppath = '../content/top15img/'.gmdate('Ym') . '/';
		$fname = md5($imgName.gmdate('YmdHis'))  .'.jpg';
		$save_img_url = getImage($matches[5], $uppath, $fname, 0, $domain);
		
		return "<a{$matches[1]}href=\"{$save_img_url}\"{$matches[3]}><img{$matches[4]}src=\"{$save_img_url}\"{$matches[6]}>";
	} else {
		return "<a{$matches[1]}href=\"{$matches[2]}\"{$matches[3]}><img{$matches[4]}src=\"{$matches[5]}\"{$matches[6]}>";
	}
}

function img2local_option()
{
?>
<input type="checkbox" value="1" name="img2local" checked="checked" />图片本地化（<span style="color:red;">仅将远程图片保存到自己服务器</span>）
<?php
}
addAction('adm_writelog_head', 'img2local_option');